
#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <stdlib.h> 
#include <malloc.h>
#include "MxGeneralIo.h"

#ifdef __cplusplus    // If used by C++ code, 
extern "C" {          // we need to export the C interface
#endif



/* MC-1112-W7E 
   First release by Sean Hsieh 2016.12.21
   4 port(232/422/485)
*/



//extern int SERIAL_PORT_NUMBER_ENABLE;
#define MAX_SERIAL_PORT_NUMBER			4
#define MAX_SERIAL_INTERFACE_NUMBER		3
	
#define UART_AUTODIRECTION_CONTROL_ADDRESS 0xF0  // In ITE Super IO



int UartModeGet(int portNum);
int UartModeSet(int portNum, int portMode);
UCHAR ReadPortData(ULONG address);
int WritePortData(ULONG	address, UCHAR ucMemData);

//
int EnableAutoDirectionControl(int portNum);
int DisableAutoDirectionControl(int portNum);
int SetAutoDirectionControl(int portNum);
UCHAR ReadSuperIoChar(ULONG address, int portNum);
int WriteSuperIoChar(ULONG	address, int portNum, UCHAR	ucMemData);

int SetRegistryValue(DWORD nPort,DWORD nMode);
int GetRegistryValue(DWORD nPort,DWORD* nMode);
HANDLE mxsp_open();
void mxsp_close();
int mxsp_get_interface(HANDLE fd, int port_index);
int mxsp_set_interface(HANDLE fd, int port_index, int port_interface);

int mxsp_check_layer(int *layerNumber);
#ifdef __cplusplus    // If used by C++ code, 
}
#endif